angular.module('b4zaar.controllers', [])

    /*
     * @name controllers.AppCtrl
     * @header controllers.AppCtrl
     * @object
     * @description
     * Main controller of the aplication takes care of the singup and singin modal views
     *
     */
    .controller('AppCtrl', function ($rootScope, $scope, $ionicModal, $timeout,
                                     $ionicHistory, $ionicPopup, $state, AuthService, User, Dialog, Message) {

        // Form data for the login modal
        $scope.loginData = {};
        // Form data for the register modal
        $scope.registerData = {};
        // Indexed productsId for the card navigation
        // TODO CANVIAR EL SISTEMA DE EVENTS PER PULL TO REFRESH
        $scope.productsIndex = [];
        // TODO CANVIAR EL SISTEMA DE EVENTS PER PULL TO REFRESH
        // Dialogs data for the user
        $scope.dialog = {};
        //$scope.product = {};
        //$scope.buyer = {};
        //$scope.seller = {};

        $scope.newMessages = 0;
        //Define an event listener for updating the user state (loged / not loged)
        // TODO Es necessari ??
        $rootScope.$on('app:userStatusChanged', function () {
            //if($scope.user) $scope.user.updateUserStatus();
            //$scope.updateUserStatus();
            $scope.is_user_loged = !$scope.is_user_loged;
        });

        // Create the login modal that we will use later
        $ionicModal.fromTemplateUrl('templates/login.html', {
            id: '1', // We need to use and ID to identify the modal that is firing the event!
            scope: $scope,
            backdropClickToClose: false,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.oModal1 = modal;
        });

        // Create the register modal that we will use later
        $ionicModal.fromTemplateUrl('templates/signup.html', {
            id: '2', // We need to use and ID to identify the modal that is firing the event!
            scope: $scope,
            backdropClickToClose: false,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.oModal2 = modal;
        });

        // Open function for modals views
        $scope.openModal = function (index) {
            console.log('openModal(' + index + ')');
            if (index == 1) $scope.oModal1.show();
            else $scope.oModal2.show();
        };

        // Triggered in the modals views to close it
        $scope.closeModal = function (index) {
            console.log('closeModal(' + index + ')');
            if (index == 1) $scope.oModal1.hide();
            else $scope.oModal2.hide();
        };

        /* Listen for broadcasted messages */

        $scope.$on('modal.shown', function (event, modal) {
            console.log('Modal ' + modal.id + ' is shown!');
        });

        $scope.$on('modal.hidden', function (event, modal) {
            console.log('Modal ' + modal.id + ' is hidden!');
        });

        // Cleanup the modals when we're done with them (i.e: state change)
        // Angular will broadcast a $destroy event just before tearing down a scope
        // and removing the scope from its parent.
        $scope.$on('$destroy', function () {
            console.log('Destroying modals...');
            $scope.oModal1.remove();
            $scope.oModal2.remove();
        });

        // Performs the goBack actions
        $scope.myGoBack = function () {
            $ionicHistory.goBack();
        };

        // Checks for neww messages related to the user
        $scope.refreshMessages = function () {

            var dialogIndex = 0;
            $scope.dialogs = {};
            $scope.dialogs.new_msg_num = 0;
            // busquem els dialegs on l'usuari sigui comprador o venedor
            var dialogs = Dialog.find(
                {'Authorization': $scope.auth.id},
                {
                    where: {
                        or: [{'sellerId': $scope.user.id}, {'buyerId': $scope.user.id}]
                    }
                },
                onFindDialogSuccess, onFindDialogFail);

            function onFindDialogSuccess(value, responseHeaders) {
                console.log('onFindDialogSuccess');
                //console.log('value.length: ');
                //console.log(value.length);
                $scope.dialogs = value;
                $scope.dialogs.new_msg_num = 0;

                var strDialogs = '';

                // generem una cadena amb tots els dialegs on participem
                for (i = 0; i < value.length; i++) {
                    console.log('dialog: ');
                    console.log(value[i]);
                    strDialogs = strDialogs + "{'dialogId': " + value[i].id + "}";
                    if (i < value.length - 1) strDialogs = strDialogs + ",";
                }

                console.log('dialog String: ');
                console.log(strDialogs);

                // recuperem aquells missatges per llegir
                // que partanyi a qualsevol dialeg on participem
                var messages = Message.find(
                    {'Authorization': $scope.auth.id},
                    {where: {and: [{'read': false}, {or: [strDialogs]}]}},
                    //{'read': false},
                    onMsgSuccess, onMsgFail);


                function onMsgSuccess(value, responseHeaders) {
                    console.log('onMsgSuccess');
                    //console.log('OJO no compleix que read sigui false sempre');
                    // workarround
                    var not_readed = 0;
                    for (i = 0; i < value.length; i++) {
                        console.log('value: ' + i);
                        console.log(value[i]);
                        if (!value[i].read) not_readed++;
                    }

                    //$scope.dialogs.new_msg_num = value.length;
                    $scope.dialogs.new_msg_num = not_readed;

                }

                function onMsgFail(httpResponse) {
                    console.log('onMsgFail');
                    console.log('Error code :' + httpResponse.status);
                }

            }

            function onFindDialogFail(httpResponse) {
                console.log('onFindMsgFail: ' + httpResponse.status);
            }
        };

        $scope.refreshUserStatus = function () {
            console.log("IN refreshUserStatus");
            User.getCurrent(
                function onSuccess(value, responseHeaders) {
                    console.log("Succes on refreshUserStatus" + value);
                    $scope.user = value;
                    $scope.is_user_loged = true;
                    // Aqui hem de calcular el estat dels missatges
                    $scope.refreshMessages();

                }, function onFail(httpResponse) {
                    console.log("Fail on refreshUserStatus" + httpResponse);
                    $scope.user = {};
                    $scope.is_user_loged = false;
                });
        };

        // Perform the login action when the user submits the login form
        $scope.doLogin = function () {
            console.log('Doing login', $scope.loginData);

            $scope.auth = AuthService.login($scope.loginData.email, $scope.loginData.password)
                .then(function () {
                    $scope.closeModal(1);
                    $scope.refreshUserStatus();
                    // actualizem l'estat del usuari
                    // millor utilitzar un event
                    //this.checkUserStatus();
                    $scope.$emit('app:userStatusChanged');
                    $state.go('app.products');
                }, function () {
                    var alertPopup = $ionicPopup.alert({
                        title: 'Error d\'autenticació!',
                        template: 'Assegurat d\'escriurer be les credencials'
                    });
                    alertPopup.then(function (res) {
                        $scope.loginData = {};
                        console.log('Error de login');
                    });
                });
        };

        // Perform the login action when the user submits the login form
        //
        $scope.doRegister = function () {
            console.log('Doing register', $scope.registerData);
            AuthService.register($scope.registerData.firstName, $scope.registerData.lastName,
                $scope.registerData.email, $scope.registerData.username, $scope.registerData.password)
                .then(function () {
                    $scope.closeModal(2);
                    $state.transitionTo('app.products');
                }, function () {
                    var alertPopup = $ionicPopup.alert({
                        title: 'Dades incomplertes!',
                        template: 'Assegurat de completar be els camps'
                    });
                    alertPopup.then(function (res) {
                        //$scope.registerData = {};
                        console.log('Error de registre');
                    });
                });
        };

        $scope.doLogout = function () {
            console.log('Doing logout');

            AuthService.logout()
                .then(function () {
                    // actualizem l'estat del usuari
                    //this.checkUserStatus();
                    // millor llencem un event
                    //$scope.user = {};
                    $scope.$emit('app:userStatusChanged');
                    $state.go('app.products');
                    console.log('Logout Done');
                }, function () {
                    console.log('Error on logout');
                });
        };

    })

    /*
     * @name controllers.ProductsCtrl
     * @header controllers.ProductsCtrl
     * @object
     * @description
     * makes GET petition to /api/products and gets the list of products
     *
     */
    .controller('ProductsCtrl', ['$rootScope', '$scope', 'Product', '$state',
        function ($rootScope, $scope, Product) {

            // I define an event listener for updating the list view
            $rootScope.$on('products:listChanged', function (productId) {
                $scope.updateList();
                // generating index for card navigation
                $scope.generateIndex(productId)
            });

            $scope.updateList = function () {
                $scope.products = Product.find();
            };

            // filter function vinculated to search text input on the view
            $scope.filterFunction = function (element) {
                return element.name.match(/^Ma/) ? true : false;
            };

            // generates the navigation id index list of filtered products list
            $scope.generateIndex = function (productid) {
                console.log("Inside generateIndex productId: " + productid);
                $scope.productsIndex.push(productid);

            };

            // gets the full list of products
            // TODO substituir per Near
            $scope.products = Product.find();


        }])

    /*
     * @name controllers.ProductCtrl
     * @header controllers.ProductCtrl
     * @object
     * @description
     * makes GET petition to /api/product/:id and gets a concrete product
     *
     */
    .controller('ProductCtrl', function ($scope, $state, $stateParams, Product, User) {

        $scope.product = {};
        $scope.seller = {};
        $scope.buyer = {};
        $scope.same_user = false;

        var product = Product.findById({id: $stateParams.productId}, onProdSuccess, onProdFail);

        function onProdSuccess(value, responseHeaders) {
            console.log('onProdSuccess');
            $scope.product = value;
            var seller = Product.user({"id": $stateParams.productId}, onSellerSuccess, onSellerFail);

            function onSellerSuccess(value, responseHeaders) {
                console.log('onSellerSuccess');
                $scope.seller = value;
                var buyer = User.getCurrent(onCurrentSuccess, onCurrentFail);

                function onCurrentSuccess(value, responseHeaders) {
                    console.log('onCurrentSuccess');
                    $scope.buyer = value;
                    $scope.same_user = ($scope.product.publisherId == $scope.buyer.id);
                    //console.log('$scope.product.publisherId');
                    //console.log($scope.product.publisherId);
                    //console.log('$scope.buyer.id');
                    //console.log($scope.buyer.id);
                    //console.log('$scope.same_user');
                    //console.log($scope.same_user);
                }

                function onCurrentFail(httpResponse) {
                    console.log('onCurrentFail: ' + httpResponse.status);
                }
            }

            function onSellerFail(httpResponse) {
                console.log('onSellerFail' + httpResponse.status);
            }

        }

        function onProdFail(httpResponse) {
            console.log('onProdFail' + httpResponse.status);
        }


        $scope.getNextProduct = function () {

            // recollir en quin index ens trovem de la llista de productes
            var actual_index = $scope.productsIndex.indexOf($stateParams.productId);
            // calculem el seguent index
            var next_index;
            // si el nou index quedes per sota del tamany del array
            if (actual_index < $scope.productsIndex.length - 1) next_index = actual_index + 1;
            // en cas contrari calculem lendex amb una operacio mod amb el tamany del array
            else next_index = (actual_index + 1) % $scope.productsIndex.length;
            $state.go('app.product', {'productId': $scope.productsIndex[next_index]});
        };

        $scope.getPrevProduct = function () {
            var actual_index = $scope.productsIndex.indexOf($stateParams.productId);
            // calculem el seguent index
            var prev_index;
            if (actual_index > 0) prev_index = actual_index - 1;
            else prev_index = $scope.productsIndex.length + (actual_index - 1 % $scope.productsIndex.length);
            // saltem al seguent producte mitjançant l'index
            $state.go('app.product', {'productId': $scope.productsIndex[prev_index]});
        };

    })

    /*
     * @name controllers.ProductAddCtrl
     * @header controllers.ProductAddCtrl
     * @object
     * @description
     * Controller of app.publish view, basically makes POST petition to /api/product/:id and publish a concrete product
     * also contains tool function to get a photo of the camera, and geolocation info
     *
     */
    .controller('ProductAddCtrl', function ($scope, $stateParams, $state, $http, Product) {
        $scope.publishData = {};

        console.log("Loading ProductAddCtrl:");


        /*
         * @name controllers.ProductAddCtrl.getLocation
         * @header controllers.ProductAddCtrl.getLocation
         * @object
         * @description
         * Gets the geolocations of the device using the GPS
         *
         */
        $scope.takePicture = function () {
            // En el navegador obtenim TypeError: Cannot read property 'getPicture' of undefined
            // cal provar amb un dispositiu real
            // aumento el timeout en les opcions per evitar problemes amb l'emulador
            navigator.camera.getPicture(onSuccess, onFail,
                {
                    sourceType: Camera.PictureSourceType.CAMERA,
                    correctOrientation: true,
                    quality: 75,
                    targetWidth: 160,
                    encodingType: Camera.EncodingType.JPEG,
                    saveToPhotoAlbum: false,
                    //destinationType: Camera.DestinationType.FILE_URI,
                    destinationType: Camera.DestinationType.DATA_URL,
                    // error en el emulador genymotion
                    timeout: 50000
                });
            function onSuccess(imageData) {
                // recollim les dades de la imatge i els hi afegim una capçalera per mostrarla en el formulari
                $scope.publishData.image = "data:image/jpeg;charset=utf-8;base64," + imageData;
                //data:image/jpeg;charset=utf-8;base64,
                $scope.$apply();
                // preparem el request per publicar l'imatge a claudinary
                var req = {
                    method: 'POST',
                    url: 'http://api.cloudinary.com/v1_1/baazar/image/upload',
                    headers: {
                        'Authorization': $scope.auth.id,
                        'Content-Type': 'application/json',
                        'X-Requested-With': 'XMLHttpRequest',
                        'Accept': '*/*'
                    },
                    // utilitzo la carrega mitjançant preset que relaxa els requeriments de seguretat
                    data: {
                        upload_preset: 'ilhjg0xl',
                        file: 'data:image/jpeg;base64,' + imageData
                    }
                };

                //console.log(req);
                // Executem la petició POST al servei de publicacio d'imatges
                $http(req)
                    .success(function (data, status) {
                        console.log("uploadPicture success");
                        // modifiquem el src de la imatge perque apunti a la copia en el nuvol
                        var img = document.getElementById('productImage');
                        img.src = data.url;
                        // guardem el valor de la url igualment per publicar amb el producte
                        $scope.publishData.image = data.url;
                    })
                    .error(function (data, status) {
                        console.log("uploadPicture fail");
                        console.log("Error HTTP: " + status);
                    });

                var img = document.getElementById('productImage');
                img.src = "data:image/jpeg;charset=utf-8;base64," + imageData;
            }

            function onFail(message) {
                alert('Error on takePicture: Failed because: ' + message);
            }

            console.log("Exiting takePicture");
        };

        /*
         * @name controllers.ProductAddCtrl.getLocation
         * @header controllers.ProductAddCtrl.getLocation
         * @object
         * @description
         * Gets the geolocations of the device using the GPS
         *
         */
        $scope.getLocation = function () {
            console.log("Inside getLocation");
            navigator.geolocation.getCurrentPosition(onSuccess, onFail,
                {
                    enableHighAccuracy: true,
                    timeout: 15000
                });
            function onSuccess(position) {
                console.log("Success on getLocation");
                console.log(position.coords);
                // afegeix el valor al model per insertar
                $scope.publishData.loc =
                {
                    latitude: position.coords.latitude,
                    longitude: position.coords.longitude
                };
                // modifica el aspecte de la vista
                console.log("Print getLocation" + position.coords.longitude + ":" + position.coords.latitude);
                var div = document.getElementById('productLocation');
                div.innerHTML = "<ul><li>Latitut: " + position.coords.latitude +
                "</li><li>Longitut: " + position.coords.longitude + "</li></ul>";
                // TODO
            }

            function onFail(message) {
                console.log("Error on getLocation");
                alert('Failed because: ' + message);
            }

            console.log("Sortint de getLocation");
        };

        /*
         * @name controllers.ProductAddCtrl.uploadProduct
         * @header controllers.ProductAddCtrl.uploadProduct
         * @object
         * @description
         * Uploads the product data to the loopback service
         *
         */
        $scope.uploadProduct = function () {
            console.log("Inside uploadProduct");
            var newProduct = Product.create(
                // accessToken on header
                {'Authorization': $scope.auth.id},
                {
                    name: $scope.publishData.name,
                    description: $scope.publishData.description,
                    image: $scope.publishData.image,
                    loc: {
                        "__type": "GeoPoint",
                        lat: $scope.publishData.loc.latitude,
                        lng: $scope.publishData.loc.longitude
                    },
                    contact: $scope.publishData.contact,
                    price: $scope.publishData.price
                }, onSuccess, onFail);

            function onSuccess(value, responseHeaders) {
                console.log("Success on uploadProduct");
                console.log(value);
                // emit the event to update the products list
                // TODO CANVIAR EL SISTEMA DE EVENTS PER PULL TO REFRESH
                $scope.$emit('products:listChanged', {productId: value.id});
                // TODO CANVIAR EL SISTEMA DE EVENTS PER PULL TO REFRESH
                $state.go('app.products');
            }

            function onFail(httpResponse) {
                console.log("Error on uploadProduct");
                console.log('Failed because: ' + httpResponse.toString());
            }

            console.log("Leaving de uploadProduct");
        };

    })

    /*
     * @name controllers.DialogsCtrl
     * @header controllers.DialogsCtrl
     * @object
     * @description
     * Controller of app.dialogs view, gets dialogs from the current user and shows them in a list
     *
     */
    .controller('DialogsCtrl', function ($scope, $stateParams, $state, $timeout, Dialog, Message) {

        $scope.diags_empty = false;
        if ($scope.dialogs.length == 0) $scope.diags_empty = true;
        console.log("Num Dialegs: " + $scope.dialogs.new_msg_num + "Empty flag: " + $scope.diags_empty);

        $scope.dialogIndex = 0;
        for (i = 0; i < $scope.dialogs.length; i++) {
            console.log('$scope.dialogs[i].id');
            console.log($scope.dialogs[i].id);
            dialogIndex = i;
            var messages = Message.find(
                {'Authorization': $scope.auth.id},
                {where: {and: [{dialogId: $scope.dialogs[i].id}, {read: false}]}},
                //{'dialogId': $scope.dialogs[i].id},
                onMsgSuccess, onMsgFail);
        }
        function onMsgSuccess(value, responseHeaders) {

            console.log('onMsgSuccess length: ' + value.length);
            // worarround per no mostrar els llegits,
            // sembla com si el find no funciona be amb els booleans
            //$scope.dialogs[$scope.dialogIndex].new_msg_num = value.length;
            var unread_msgs = 0;
            for (i = 0; i < value.length; i++) {
                if (!value[i].read) unread_msgs++;
            }
            $scope.dialogs[$scope.dialogIndex].new_msg_num = unread_msgs;
        }

        function onMsgFail(httpResponse) {
            console.log('onMsgFail' + httpResponse.status);
        }
    })

    /*
     * @name controllers.DialogAddCtrl
     * @header controllers.DialogAddCtrl
     * @object
     * @description
     *
     *
     */
    .controller('DialogAddCtrl', function ($scope, $rootScope, $stateParams, $state, $ionicModal, User, Product, Dialog) {

        //console.log('DialogAddCtrl IN');
        //console.log('$stateParams.productId: ');
        //console.log($stateParams.productId);

        $scope.product = {};
        $scope.buyer = {};
        $scope.dialog = {};

        // busca el producte asincronament
        var product = Product.findById({include: {user: 'Users'}}, {id: $stateParams.productId}, onProdSuccess, onProdFail);

        function onProdSuccess(value, responseHeaders) {
            console.log('onProdSuccess');
            console.log('value');
            console.log(value);
            $scope.product = value;
        }

        function onProdFail(httpResponse) {
            console.log('onProddFail: ' + httpResponse.status);
        }

        // busca comprador sincronament
        $scope.buyer = User.getCurrent();

        console.log('$stateParams.productId');
        console.log($stateParams.productId);
        console.log("scope.buyer: ");
        console.log($scope.buyer);



        var dialog = Dialog.findOne(
            {'Authorization': $scope.auth.id},
            {'where': {and: [{'buyerId': $scope.buyer.id}, {'productId': $stateParams.productId}]}}
            , onDiagSuccess, onDiagFail);

        function onDiagSuccess(value, resposeHeaders) {
            // Existeix un dialeg previ
            //console.log('Existeix dialeg previ');
            console.log('onDiagSuccess');

            console.log("scope.buyer: ");
            console.log($scope.buyer);
            //console.log("scope.seller: ");
            //console.log($scope.seller);
            console.log("$scope.product");
            console.log($scope.product);

            $scope.dialog = value;
            //console.log('value');
            //console.log(value);
            $state.go('app.dialog', {'dialogId': $scope.dialog.id});
        }

        function onDiagFail(httpResponse) {
            console.log('onDiagFail: ' + httpResponse.status);
            // Hem de crear un dialeg nou
            //console.log('No existeix dialeg previ');

            console.log("scope.buyer: ");
            console.log($scope.buyer);
            //console.log("scope.seller: ");
            //console.log($scope.seller);
            console.log("$scope.product");
            console.log($scope.product);

            var seller = Product.user({"id": $stateParams.productId}, onSellerSuccess, onSellerFail);

            function onSellerSuccess(value, responseHeaders) {
                $scope.seller = value;
                var new_dialog = Dialog.create(
                    {'Authorization': $scope.auth.id},
                    {
                        //subject: $scope.product.name + ' (' + $scope.seller.username + ')',
                        subject: $scope.product.name,
                        image: $scope.product.image,
                        productId: $scope.product.id,
                        sellerId: $scope.seller.id,
                        buyerId: $scope.buyer.id
                    }, onNewDiagSuccess, onNewDiagFail);

                function onNewDiagSuccess(value, responseHeaders) {
                    console.log('onDiagSuccess');
                    $scope.dialog = value;
                    console.log('value');
                    console.log(value);
                    $state.go('app.dialog', {'dialogId': $scope.dialog.id});
                }

                function onNewDiagFail(httpResponse) {
                    console.log('onDiagFail:' + httpResponse.status);
                }
            }
            function onSellerFail(httpResponse) {
                console.log('onSellerFail:' + httpResponse.status);
            }

        }

        console.log("scope.dialog: ");
        console.log($scope.dialog);


    })

    /*
     * @name controllers.DialogCtrl
     * @header controllers.DialogCtrl
     * @object
     * @description
     * Controller of app.dialogs view, gets the messages from the current dialog
     * can be used
     *
     */
    .controller('DialogCtrl', function ($scope, $ionicScrollDelegate, $stateParams,
                                        $state, $timeout, User, Dialog, Product, Message) {
        $scope.dialog = {};
        $scope.buyer = {};
        $scope.seller = {};
        $scope.product = {};
        $scope.messages = [];

        //timeout of 4s
        $timeout(callAtTimeout, 4000);


        var dialog = Dialog.findById({id: $stateParams.dialogId},
            onFindDiagSuccess, onFindDiagFail);

        function onFindDiagSuccess(value, responseHeaders) {
            console.log('onFindDiagSuccess: ');

            // assignem al model
            $scope.dialog = value;

            // obtenim el producte del dialeg
            var product = Product.findById({id: $scope.dialog.productId}, onProdSuccess, onProdFail);

            function onProdSuccess(value, responseHeaders) {
                console.log('onProdSuccess')
                $scope.product = value;

                var seller = Product.user({"id": $scope.dialog.productId}, onSellerSuccess, onSellerFail);

                function onSellerSuccess(value, responseHeaders) {
                    console.log('onFindSellerSuccess');
                    // asignem al model
                    $scope.seller = value;

                    var buyer = Dialog.buyer({id: $scope.dialog.id}, onFindBuyerSuccess, onFindBuyerFail);

                    function onFindBuyerSuccess(value, responseHeaders) {
                        console.log('onFindBuyerSuccess');
                        // assignem al model
                        $scope.buyer = value;

                        var messages = Message.find(
                            {'Authorization': $scope.auth.id},
                            {'dialogId': $stateParams.dialogId},
                            onFindMsgSuccess, onFindMsgFail);

                        function onFindMsgSuccess(value, responseHeaders) {
                            console.log('onFindMsgSuccess: ');
                            $scope.messages = value;

                            //console.log('$scope.dialog');
                            //console.log($scope.dialog);
                            //console.log('$scope.product');
                            //console.log($scope.product);
                            //console.log('$scope.buyer');
                            //console.log($scope.buyer);
                            //console.log('$scope.seller');
                            //console.log($scope.seller);
                            //console.log('$scope.product');
                            //console.log($scope.product);

                            // recollim el id de usuari
                            var userid = User.getCurrentId();
                            // maquem com a llegits aquells missatges on som lectors
                            var messages = Message.updateAll(
                                {where: {and: [{readerId: userid}, {read: false}]}},
                                {read: true},
                                onUpdateSuccess, onUpdateFail);

                            function onUpdateSuccess(value, responseHeaders) {
                                console.log('onUpdateSuccess');
                                console.log(value.length + ' readed Messages...');
                                console.log(value);
                            }

                            function onUpdateFail(httpResponse) {
                                console.log('onUpdateFail: ' + httpResponse.status);
                            }


                            console.log('$scope.messages.length:' + $scope.messages.length);
                            for (i = 0; i < $scope.messages.length; i++) {
                                console.log('message: ');
                                console.log($scope.messages[i]);
                            }

                        }
                        function onFindMsgFail(httpResponse) {
                            console.log('onFindMsgFail ' + httpResponse.status);
                        }
                    }
                    function onFindBuyerFail(httpResponse) {
                        console.log('onFindBuyerFail ' + httpResponse.status);
                    }
                }
                function onSellerFail(httpResponse) {
                    console.log('onFindSellerFail' + httpResponse.status);
                }
            }
            function onProdFail(httpResponse) {
                console.log('onProdFail: ' + httpResponse.status);

            }
        }
        function onFindDiagFail(httpResponse) {
            console.log('onFindDiagFail' + httpResponse.status);
        }

        // Calling funtion to send a message
        $scope.sendMessage = function (text) {

            // nomes passa a true si el que envia el missatge es el venedor
            // $scope.way = ($scope.user.id == $scope.seller.id);

            var readerId;
            if ($scope.user.id == $scope.seller.id) {
                $scope.way = true;
                readerId = $scope.buyer.id;
            }
            else {
                $scope.way = false;
                readerId = $scope.seller.id;
            }

            // create a new object messatge and put it on the collection
            var msg = Message.create(
                {'Authorization': $scope.auth.id},
                {
                    'dialogId': $scope.dialog.id,
                    'readerId': readerId,
                    'text': text,
                    'way': $scope.way
                },
                onNewMsgSuccess, onNewMsgFail);

            function onNewMsgSuccess(value, responseHeaders) {
                console.log('onNewMsgSuccess :' + value.id);
                // load the full message to the local array
                $scope.messages.push(value);
                $scope.scrollBottom();
            }

            function onNewMsgFail(httpResponse) {
                console.log('onNewMsgFail Error code :' + httpResponse.status);
            }

        };

        $scope.scrollBottom = function () {
            $ionicScrollDelegate.scrollBottom();
        };

        // timeout pull function
        function callAtTimeout() {
            console.log("Timeout occurred");
            var dialog = Dialog.findById({id: $stateParams.dialogId}
                , onDiagUpdateSuccess, onDiagUpdateFail);

            function onDiagUpdateSuccess(value, responseHeaders) {
                console.log('onDiagUpdateSuccess');
                console.log('Value for $scope.dialog');
                console.log(value);
                $scope.dialog = value;
                var messages = Message.find(
                    {'Authorization': $scope.auth.id},
                    {'dialogId': $stateParams.dialogId},
                    onMsgUpdateSuccess, onMsgUpdateFail);

                function onMsgUpdateSuccess(value, responseHeaders) {
                    console.log('onFindMsgSuccess: ');
                    $scope.messages = value;
                    $scope.scrollBottom();

                    console.log('$scope.messages.length:' + $scope.messages.length);
                    for (i = 0; i < $scope.messages.length; i++) {
                        console.log('message: ');
                        console.log($scope.messages[i]);
                    }
                }

                function onMsgUpdateFail(httpResponse) {
                    console.log('onFindMsgFail ' + httpResponse.status);
                }

            }

            function onDiagUpdateFail(httpResponse) {
                console.log('onDiagUpdateFail: ' + httpResponse.status);
            }

            $timeout(callAtTimeout, 3000);
        }

        // Al carregar que baixi a baix de tot
        $scope.scrollBottom();
    });